;  mIRCScout by Istari

; :: script - public

alias q3ping { q3query $1- }
alias mIRCScout { openms }
alias q3exe { return $readini $mircini mIRCScout q3exe }
alias runq3 { run $q3exe +set fs_basepath $nofile($q3exe) $1- }

menu channel,query,menubar,status {
  mIRCScout
  .open favourites: openms
  .ping ip: q3query $$?="enter ip:port"
  .setup: mssetup
  .help: sshelp
}

menu @mIRCScout.PlayerWindow {
  red team: /addplayer_red $2-
  blue team: /addplayer_blue $2-
  remove from team: /removeplayer $2-
}

; :: script - private/internal

alias -l msversion {
  return 1.0
}

alias -l addplayer_red {
  %mIRCScout.blueplayers = $remtok(%mIRCScout.blueplayers,$1-,1,165)
  %mIRCScout.redplayers = $addtok(%mIRCScout.redplayers,$1-,165)
  addplayers
}

alias -l addplayer_blue {
  %servercout.redplayers = $remtok(%mIRCScout.redplayers,$1-,1,165)
  %mIRCScout.blueplayers = $addtok(%mIRCScout.blueplayers,$1-,165)
  addplayers
}

alias -l removeplayer {
  %mIRCScout.blueplayers = $remtok(%mIRCScout.blueplayers,$1-,1,165)
  %mIRCScout.redplayers = $remtok(%mIRCScout.redplayers,$1-,1,165)
  addplayers
}

alias -l mssetup { setnewpath }

alias setnewpath {
  var %newpath = $shortfn( [ $dir="Select quake 3 executable" c:\ ] )
  if $null isin %newpath { }
  else {
    writeini [ $mircini mIRCScout q3exe %newpath ] 
    if $dialog(mIRCScout) != $null { did -o mIRCScout 36 1 %newpath }
  }
}

alias -l q3query {
  if $1 == $null { echo Error: No ip specified. | halt }
  if (( $gettok($1,1,46) isnum 0-255) && ($gettok($1,2,46) isnum 0-255) && ($gettok($1,3,46) isnum 0-255)) {
    set %mIRCScout.port 27960
    if : isin $1 { %mIRCScout.port = $gettok($1,2,58) }
    if $2 == $null {
      sockudp -k mIRCScout $gettok($1,1,58) %mIRCScout.port getstatus
      set %mIRCScout.ip $1
      set %mIRCScout.startping $ticks
      if $dialog(mIRCScout) == $null {
        openms
      }
      did -o mIRCScout 5 1 %mIRCScout.ip
      did -o mIRCScout 33 1 Querying server...
      .timertimeout 1 1 timeout
    }
    else {
      sockudp -k mIRCScout.Quick $+ $2 $gettok($1,1,58) %mIRCScout.port getstatus
    }
  }
  else {
    set %mIRCScout.dns 1 $2
    set %mIRCScout.port $gettok($1,2,58)
    .dns $gettok($1,1,58)
  }
}

on *:dns: {
  if %mIRCScout.dns != $null {
    q3query $raddress $+ $iif(%mIRCScout.port != $null,: [ $+ [ %mIRCScout.port ] ] ) $gettok(%mIRCScout.dns,2,32)
    unset %mIRCScout.dns
    halt
  }
}

alias -l timeout {
  sockclose mIRCScout
  did -o mIRCScout 33 1 No response.
}

alias -l openms {
  if $window(@mIRCScout.PlayerWindow) == $null {
    window -kphldo +deL @mIRCScout.PlayerWindow $calc($dialog(mIRCScout).x + 15) $calc($dialog(mIRCScout).y + 223) 110 185 ms sans serif
  }
  .timerhej -m 0 200 updateplayerwindow
  if $dialog(mIRCScout) == $null {
    set %mircscout.logo $scriptdirlogo.bmp
    dialog -m mIRCScout mIRCScout
  }
  did -o mIRCScout 33 1 All systems nominal.
  did -o mIRCScout 36 1 $q3exe
  loadfavourites
}

alias -l loadfavourites {
  did -r mIRCScout 45
  var %x = 1
  while (%x <= $favourite(0)) {
    did -a mIRCScout 45 $favourite(%x)    
    inc %x 
  }
}

alias  favourite {
  if ($1 isnum 1-200) {
    if ($prop == port) { var %temp = $read -l $+ $1 $scriptdirq3servers.txt | return $iif($gettok(%temp,2,58) == $null, 27960, $gettok(%temp,2,58)) }
    if ($prop == ip) { var %temp = $read -l $+ $1 $scriptdirq3servers.txt | return $gettok(%temp,1,58) }
    return $read -l $+ $1 $scriptdirq3servers.txt
  }
  elseif ($1 == 0) {
    return $lines($scriptdirq3servers.txt)
  }
}

alias -l quickfind {
  var %x = $favourite(0)
  while (%x > 0) {
    sockudp -k mIRCScout.Quick [ $+ . $+ [ %x ] ]  $favourite(%x).ip $favourite(%x).port  getstatus
    sockmark mIRCScout.Quick [ $+ . $+ [ %x ] ] $favourite(%x)
    dec %x
  }
  progressbar
}

alias -l progressbar {
  did -o mIRCScout 33 1 Scanning favourites...
  .timerlookatfavs 1 1 sortoutservers
}

alias -l sortoutservers {
  if ($dialog(mIRCScout) == $null) { sockclose mIRCScout* | halt }
  loadfavourites
  did -o mIRCScout 33 1 No servers found.
  var %x = $favourite(0)
  while (%x > 0) {
    if ($istok($sock(mIRCScout.Quick [ $+ . $+ [ %x ] ] ).mark , response, 181) == $false) { goto next }
    if $istok($sock(mIRCScout.Quick [ $+ . $+ [ %x ] ] ).mark , declined, 181) { goto next }
    if $istok(%mIRCScout.criteria, empty,181) { if $istok($sock(mIRCScout.Quick [ $+ . $+ [ %x ] ] ).mark, populated,181) { goto next } }
    elseif $istok(%mIRCScout.criteria, populated,181) { 
      if ($istok($sock(mIRCScout.Quick [ $+ . $+ [ %x ] ] ).mark, populated,181) == $false) { goto next } 
    } 
    if (($istok(%mIRCScout.criteria, none,181) ==  $false) && ($istok($sock(mIRCScout.Quick [ $+ . $+ [ %x ] ] ).mark , foundplayer, 181) ==  $false)) { goto next }
    did -o mIRCScout 33 1 Server found.
    did -o mIRCScout 45 %x $did(mIRCScout,45,%x).text ***
    :next
    dec %x
  }
}

on *:udpread:mIRCScout.Quick*: {
  var %temp
  sockread %temp
  sockmark $sockname $addtok($sock($sockname).mark,response,181)
  if ($left(%temp, 1) == \) { 
    if (($gettok(%mIRCScout.criteria,1,181) iswm $gettok(%temp, $calc($findtok(%temp, g_gametype, 1, 92) + 1), 92)) && ( $gettok(%mIRCScout.criteria,3,181) iswm $gettok(%temp, $calc($findtok(%temp, fs_game, 1, 92) + 1), 92))) { return }
    sockmark $sockname $addtok($sock($sockname).mark,declined,181)
  }
  elseif $gettok(%temp,1,32) isnum {
    sockmark $sockname $addtok($sock($sockname).mark,populated,181)
    if ($gettok(%mIRCScout.criteria,4,181)  iswm $strip($colourize($gettok(%temp,2,34)))) {
      sockmark $sockname $addtok($sock($sockname).mark,foundplayer,181)
    }
  }
}


on *:udpread:mIRCScout: {
  var %temp
  sockread %temp
  if %temp == statusResponse {
    .timertimeout off
    .timerl33t -m 1 100 addplayers
    unset %mIRCScout.clients
    did -o mIRCScout 28 1 $calc($ticks - %mIRCScout.startping)
    did -o mIRCScout 33 1 Response received.
    unset %mIRCScout.clientstr
    clear @mIRCScout.PlayerWindow
    did -r mIRCScout 16,17,20
  }
  elseif $left(%temp, 1) == \ {
    did -o mIRCScout 24 1 $gettok(%temp, $calc($findtok(%temp, mapname, 1, 92) + 1), 92)
    did -o mIRCScout 7 1 $gettok(%temp, $calc($findtok(%temp, version, 1, 92) + 1), 92)
    did -o mIRCScout 32 1 $gettok(%temp, $calc($findtok(%temp, fraglimit, 1, 92) + 1), 92)
    did -o mIRCScout 30 1 $gettok(%temp, $calc($findtok(%temp, timelimit, 1, 92) + 1), 92)
    did -o mIRCScout 3 1 $gettok(%temp, $calc($findtok(%temp, sv_hostname, 1, 92) + 1), 92)
    did -o mIRCScout 26 1 $replace($gettok(%temp, $calc($findtok(%temp, g_gametype, 1, 92) + 1), 92), 0, DM, 1, Tournament, 3, Team DM, 4, CTF, 2, Single Player)
    did -o mIRCScout 12 1 $gettok(%temp, $calc($findtok(%temp, sv_maxclients, 1, 92) + 1), 92)
    did -o mIRCScout 19 1 $gettok(%temp, $calc($findtok(%temp, sv_privateclients, 1, 92) + 1), 92)
    if $istok(%temp,fs_game,92) { did -o mIRCScout 68 1 $gettok(%temp, $calc($findtok(%temp, fs_game, 1, 92) + 1), 92) }
    else { did -r mIRCScout 68 }
  }
  elseif $gettok(%temp,1,32) isnum {
    var %temp2 = $replace($colourize($gettok(%temp,2,34)),$null,noname) $+  $+ $gettok($gettok(%temp,1,34),1,32) $+  $+ $gettok($gettok(%temp,1,34),2,32) $+  $+ $player(0) 
    %mIRCScout.clients = $addtok(%mIRCScout.clients,  %temp2 , 165)
  }
}

alias -l player {
  if ($1 isnum 1-200) {
    if ($prop == frags) { return $gettok($gettok(%mIRCScout.clients,$1,165),2,181)  }
    if ($prop == ping) { return  $gettok($gettok(%mIRCScout.clients,$1,165),3,181)  }
    if ($prop == userid) { return  $gettok($gettok(%mIRCScout.clients,$1,165),4,181)  }
    return $gettok($gettok(%mIRCScout.clients,$1,165),1,181)
  }
  elseif ($1 == 0) {
    return $numtok(%mIRCScout.clients,165)
  }
}

alias -l sortedplayer {
  if ($prop == $null) { return $player($gettok(%mIRCScout.SortedPlayers,$1,165)) }
  return $player($gettok(%mIRCScout.SortedPlayers,$1,165)) [ $+ . $+ [ $prop ] ]
}

alias -l colourize { return $replace($1-,^1,04,^!,04,^2,03,^",03,^3,08,^#,08,^4,12,^,12,^5,11,^%,11,^6,13,^&,13,^7,,^/,,^=,,^8,,^9,04,^q,04,^w,,^^0, ^14,^],,^[,,^k,,^r,04) }

alias sortplayers {
  unset %mIRCScout.SortedPlayers
  var %x = $player(0)
  while (%x > 0) {
    if ($1 == frags) { var %tempplayers = $sorttok($instok(%tempplayers, $instok($player(%x).frags , $player(%x).userid, 100, 181),100 ,165), 165, nr) }
    elseif ($1 == ping) { var %tempplayers = $sorttok($instok(%tempplayers, $instok($player(%x).ping , $player(%x).userid, 100, 181), 100 ,165), 165, n) }
    elseif ($1 == userid) { var %tempplayers = $sorttok($instok(%tempplayers, $instok($player(%x).userid, $player(%x).userid, 100, 181), 100, 165), 165, n) }
    else { var %tempplayers = $sorttok($instok(%tempplayers, $instok($strip($player(%x)) , $player(%x).userid, 100, 181), 100 ,165), 165) }
    dec %x
  }
  %x = 1
  while (%x <= $player(0) ) {
    %mIRCScout.SortedPlayers = $instok(%mIRCScout.SortedPlayers, $calc($gettok($gettok(%tempplayers,%x,165),2,181) + 1), 100, 165)
    inc %x
  }
}


alias -l addplayers {
  did -o mIRCScout 10 1 $player(0)
  var %temp2 = 0
  sortplayers $readini $mircini mIRCScout sortby
  %mIRCScout.redfrags = 0
  %mIRCScout.bluefrags = 0
  %mIRCScout.blueping = 0
  %mIRCScout.redping = 0
  %mIRCScout.rodaspelare = 0
  %mIRCScout.blaspelare = 0
  clear @mIRCScout.PlayerWindow
  did -r mIRCScout 16
  did -r mIRCScout 17
  did -r mIRCScout 20
  while ($player(0) > %temp2) {
    inc %temp2
    if $istok(%mIRCScout.blueplayers,$sortedplayer(%temp2),165) { var %icon = 12<> | %mIRCScout.bluefrags = $calc(%mIRCScout.bluefrags + $sortedplayer(%temp2).frags) | %mIRCScout.blueping = $calc(%mIRCScout.blueping + $sortedplayer(%temp2).ping) | inc %mIRCScout.blaspelare }
    elseif $istok(%mIRCScout.redplayers,$sortedplayer(%temp2),165) { var %icon = 4<> | %mIRCScout.redfrags = $calc(%mIRCScout.redfrags + $sortedplayer(%temp2).frags) | %mIRCScout.redping = $calc(%mIRCScout.redping + $sortedplayer(%temp2).ping) | inc %mIRCScout.rodaspelare }
    else { var %icon = 14<> }
    aline @mIRCScout.PlayerWindow %icon $sortedplayer(%temp2)
    did -a mIRCScout 16  $sortedplayer(%temp2).frags
    did -a mIRCScout 17  $sortedplayer(%temp2).ping
    did -a mIRCScout 20  $sortedplayer(%temp2).userid
    did -o mIRCScout 65 1 %mIRCScout.redfrags
    did -o mIRCScout 66 1 %mIRCScout.bluefrags
    did -o mIRCScout 69 1 $int($calc(%mIRCScout.redping / %mIRCScout.rodaspelare))
    did -o mIRCScout 70 1 $int($calc(%mIRCScout.blueping / %mIRCScout.blaspelare))
  }
}

alias -l sshelp { 
  dialog -m mIRCScoutHelp mIRCScoutHelp
  sockopen mIRCScoutFAQ 195.163.107.12 80
}

on *:sockopen:mIRCScoutFAQ: {
  sockwrite $sockname GET http://hem1.passagen.se/qman/faq.ss HTTP/1.1 $+ $crlf $+ Host: $ip $+ $crlf $+ $crlf
}

on *:sockread:mIRCScoutFAQ: {
  var %temp
  sockread %temp
  if ($gettok(%temp,1,32) == Version) { if ($gettok(%temp,2,32) > $msversion) { .timer -m 1 1 getnewversion }  }
  elseif ($left(%temp,1) == ) {
    did -a mIRCScoutHelp 6 $replace(%temp,,$chr(160)) $+ $crlf
  }
  elseif ($left(%temp,1) == ) {
    did -a mIRCScoutHelp 3 $replace(%temp,,$chr(160)) $+ $crlf
  }
  elseif ($left(%temp,3) == EOF) { sockclose mIRCScoutFAQ }
}

alias getnewversion {
  if ($?!="A newer version than you possess has been released, download the newest version?") {
    run http://www.anthillmob.org/mircscout/dlms.asp
  }
}

dialog mIRCScoutHelp {
  title "mIRCScout  Help section"
  size -1 -1 530 400

  box "",1, 5 5 250 360
  text "Known bugs/issues",2,15 15 100 15
  edit "", 3,10 30 240 320, multi read vsbar

  box "",4, 270 5 250 360
  text "FAQ",5,280 15 100 15
  edit "", 6, 275 30 240 320, multi read vsbar

  button "Done",100, 100 370 100 20, ok default
  button "Readme", 101, 210 370 100 20
  button "Bug report", 102, 320 370 100 20
}

on *:dialog:mIRCScoutHelp:sclick:*: {
  if ($did == 101) {
    run $scriptdirmircscout.txt
  }
  elseif ($did == 102) {
    run $scriptdirbugreport.txt
  }
}

dialog mIRCScout {
  title "mIRCScout v1.0 by Istari"
  size -1 -1 580 445

  box "",1,5 5 220 130
  text "hostname", 2, 15 15 210 15
  edit "", 3, 10 30 200 20, read center
  text "ip address", 4, 15 50 210 15
  edit "", 5, 10 65 200 20, read center
  text "version", 6, 15 85 210 15
  edit "", 7, 10 100 200 20, read center

  box "",8,5 135 220 305
  text "players", 9, 25 145 60 15
  edit "", 10, 10 160 65 20, read center
  text "maxclients", 11, 85 145 60 15
  edit "", 12, 80 160 65 20, read center
  text "privateclients", 18, 150 145 80 15
  edit "", 19, 150 160 65 20, read center

  button "name", 13, 15 185 30 15
  button "frags", 14, 130 185 30 15
  button "ping", 21, 160 185 25 15
  button "userid", 15, 187 185 30 15
  list 16, 127 200 29 200
  list 17, 157 200 29 200
  list 20, 187 200 29 200
  text "red team", 63, 30 392 60 20
  text "blue team", 64, 30 412  60 20
  edit "",65, 127 390 29 20, read
  edit "",66, 127 410 29 20, read
  edit "",69,157 390 29 20, read
  edit "",70,157 410 29 20, read

  box "", 22,230 5 160 200
  text "map",23,240 15 100 15
  edit "",24,235 30 150 20, read center
  text "gametype",25,240 50 100 15
  edit "",26,235 65 150 20, read center
  text "ping",27,240 85 100 15
  edit "",28,235 100 150 20, read center
  text "timelimit",29,240 120 100 15
  edit "",30,235 135 150 20, read center
  text "fraglimit",31,240 155 100 15
  edit "",32,235 170 150 20, read center

  box "", 34, 230 205 160 160
  text "quake 3 executable", 35, 240 215 100 15
  edit "", 36, 235 230 150 20, read center
  button "",37,  350 215 15 15
  text "password", 38, 240 250 150 15
  edit "", 39, 235 265 150 20
  text "nick", 40, 240 285 150 15
  edit "", 41, 235 300 150 20
  text "fs_game", 67, 240 320 150 15
  edit "", 68, 235 335 150 20

  box "", 42, 230 365 160 75
  edit "", 33, 235 375 150 20, read center

  button "refresh", 101, 286 400 48 22, default
  button "connect", 102, 235 400 48 22
  button "exit", 100, 337 400 48 22, ok

  box "", 43, 395 5 172 218
  text "favourites", 44, 405 15 100 15
  list 45, 400 30 160 170
  button "+",47, 425 195 50 20
  button "-",48, 485 195 50 20

  box "",49,395 223 172 142
  text "quickfind",50,405 233 100 15
  check "empty",51,400 248 60 15
  check "populated", 56, 480 248 70 15
  check "tournament",52, 400 263 80 15
  check "team dm",53, 400 278 60 15
  check "ffa",54, 480 263 60 15
  check "ctf",55, 480 278 60 15
  text "fs_game",57,402 297 40 15
  edit "",58, 450 293 100 20
  text "player",59,402 317 40 15
  edit "",60,450 313 100 20
  button "go",61,415 335 60 18
  button "help", 62, 480 335 60 18

  icon 105, 395 370 171 69, %mircscout.logo
}


alias -l updateplayerwindow {
  if $dialog(mIRCScout) == $null {
    window -c @mIRCScout.PlayerWindow
    .timerhej off
  }
  elseif $appactive {
    if $window(@mIRCScout.PlayerWindow).state == hidden {
      window -a @mIRCScout.PlayerWindow $calc($dialog(mIRCScout).x + 15) $calc($dialog(mIRCScout).y + 223)
    }
    else {
      window @mIRCScout.PlayerWindow $calc($dialog(mIRCScout).x + 15) $calc($dialog(mIRCScout).y + 223)
    }
  }
  else {
    window -h @mIRCScout.PlayerWindow $calc($dialog(mIRCScout).x + 15) $calc($dialog(mIRCScout).y + 223)
  }
}


; :: events

on *:load: {
  if ($version < 5.7) { echo Your mIRC version is outdated. Get mIRC version 5.7 or later at www.mirc.com ! | .unload -rs $script | halt ) }
  mssetup
  writeini $mircini mIRCScout sortby name
}

on ^*:hotlink:*.*.*.*:* {
  if (( $gettok($1,1,46) isnum 0-255) && ($gettok($1,2,46) isnum 0-255) && ($gettok($1,3,46) isnum 0-255)) { return }
  else { halt }
}

on *:hotlink:*.*.*.*:* {
  var %temp = $gettok($hotline,$calc($findtok($hotline,$1,1,32) + 1),32)
  if (%temp isnum 10000-50000) {
    q3ping $1 $+ : $+ %temp
  }
  else {
    q3ping $1
  }
}

on *:dialog:mIRCScout:dclick:*: {
  if $did == 45 {
    q3query $gettok($did(mIRCScout, 45, $did(mIRCScout,45,1).sel).text,1,32)
  }
}

on *:dialog:mIRCScout:sclick:*: {
  if $did == 37 {
    .timertemp18 -m 1 1 setnewpath
  }
  elseif $did == 101 {
    if $did(mIRCScout,5).text != $null {
      q3query $did(mIRCScout,5).text
    } 
    else {
      did -o mIRCScout 33 1 No server specified.
    }
  }
  elseif $did == 100 {
    sockclose mIRCScout*
    unset %mIRCScout.*
  }
  elseif $did == 102 {
    if $did(mIRCScout,5).text != $null {
      runq3 +connect %mIRCScout.ip $iif($did(mIRCScout,39), +set password [ $did(mIRCScout,39) ] )  $iif($did(mIRCScout,41), +set name [ $did(mIRCScout,41) ] ) $iif($did(mIRCScout,68), +set fs_game [ $did(mIRCScout,68) ] )
    } 
    else {
      did -o mIRCScout 33 1 No server specified.
    }
  }

  ;- ### Populated / empty checkboxes ###
  elseif $did == 51 {
    if $did(mIRCScout,51).state == 1 {
      did -b mIRCScout 56
    }
    else {
      did -e mIRCScout 56
    }
  }
  elseif $did == 56 {
    if $did(mIRCScout,56).state == 1 {
      did -b mIRCScout 51
    }
    else {
      did -e mIRCScout 51
    }
  }

  ;- ### Gametype checkboxes ###
  elseif $did == 52 {
    if $did(mIRCScout,52).state == 1 {
      did -b mIRCScout 53,54,55
    }
    else {
      did -e mIRCScout 53,54,55
    }
  }
  elseif $did == 53 {
    if $did(mIRCScout,53).state == 1 {
      did -b mIRCScout 52,54,55
    }
    else {
      did -e mIRCScout 52,54,55
    }
  }

  elseif $did == 54 {
    if $did(mIRCScout,54).state == 1 {
      did -b mIRCScout 53,52,55
    }
    else {
      did -e mIRCScout 53,52,55
    }
  }

  elseif $did == 55 {
    if $did(mIRCScout,55).state == 1 {
      did -b mIRCScout 53,54,52
    }
    else {
      did -e mIRCScout 53,54,52
    }
  }

  ;- ### When the user presses the go button in the quickfind box ###
  elseif $did == 61 {
    if ($did(mIRCScout,52).state == 1) {
      %mIRCScout.criteria = 1  
    }
    elseif ($did(mIRCScout,53).state == 1) {
      %mIRCScout.criteria = 3    
    }
    elseif ($did(mIRCScout,54).state == 1) {
      %mIRCScout.criteria = 0
    }
    elseif ($did(mIRCScout,55).state == 1) {
      %mIRCScout.criteria = 4
    }
    else {
      %mIRCScout.criteria = *
    }
    if ($did(mIRCScout,51).state == 1) {
      %mIRCScout.criteria = $instok(%mIRCScout.criteria,empty,100,181)
    }
    elseif ($did(mIRCScout,56).state == 1) {
      %mIRCScout.criteria = $instok(%mIRCScout.criteria,populated,100,181)
    }
    else {
      %mIRCScout.criteria = $instok(%mIRCScout.criteria,*,100,181)
    }
    if ($did(mIRCScout,58).text != $null) {
      %mIRCScout.criteria = $instok(%mIRCScout.criteria,$ifmatch,100,181)
    }
    else {
      %mIRCScout.criteria = $instok(%mIRCScout.criteria,*,100,181)
    }
    if ($did(mIRCScout,60).text != $null) {
      %mIRCScout.criteria = $instok(%mIRCScout.criteria,$ifmatch,100,181)
    }
    else {
      %mIRCScout.criteria = $instok(%mIRCScout.criteria,none,100,181)
    }
    quickfind
  }

  elseif $did == 47 {
    .timer -m 1 1 addserver
  }

  elseif $did == 48 {
    write -dl $+ $did(mIRCScout,45,1).sel $scriptdirq3servers.txt
    loadfavourites
  }

  elseif (($did == 13) || ($did == 14) || ($did == 21) || ($did == 15)) {
    writeini $mircini mIRCScout sortby $did(mIRCScout,$did).text
    addplayers
  }

  elseif ($did == 62) { dialog -x mIRCScout | sshelp }

elseif ($did == 105) { run http://www.anthillmob.org/ }

}

alias -l addserver {
  write $scriptdirq3servers.txt $$?="input ip:port"
  loadfavourites
}
